# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files textelibre.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys

import platform
if platform.system=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *

sys.path.append("../Divers/")
from pro_divers import *




class Textelibre:

    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self,parent):
        self.parent=parent
        interface = gtk.Builder()
        interface.add_from_file('../Divers/textelibre.glade')
        self.windowTL=interface.get_object("windowTL")
        self.checkbuttonTL1 = interface.get_object("checkbuttonTL1")
        self.checkbuttonTL2= interface.get_object("checkbuttonTL2")
        self.checkbuttonTL3 = interface.get_object("checkbuttonTL3")
        self.checkbuttonTL4 = interface.get_object("checkbuttonTL4")
        self.checkbuttonTL5 = interface.get_object("checkbuttonTL5")
        
        self.entryTL1 = interface.get_object("entryTL1")
        self.entryTL2 = interface.get_object("entryTL2")
        self.entryTL3 = interface.get_object("entryTL3")
        self.entryTL4 = interface.get_object("entryTL4")
        self.entryTL5 = interface.get_object("entryTL5")
        
        self.entryXTL1 = interface.get_object("entryXTL1")
        self.entryXTL2 = interface.get_object("entryXTL2")
        self.entryXTL3 = interface.get_object("entryXTL3")
        self.entryXTL4 = interface.get_object("entryXTL4")
        self.entryXTL5 = interface.get_object("entryXTL5")
        
        self.entryYTL1 = interface.get_object("entryYTL1")
        self.entryYTL2 = interface.get_object("entryYTL2")
        self.entryYTL3 = interface.get_object("entryYTL3")
        self.entryYTL4 = interface.get_object("entryYTL4")
        self.entryYTL5 = interface.get_object("entryYTL5")
        
        self.comboboxCouleurTL1 = interface.get_object("comboboxCouleurTL1")
        self.comboboxCouleurTL2 = interface.get_object("comboboxCouleurTL2")
        self.comboboxCouleurTL3 = interface.get_object("comboboxCouleurTL3")
        self.comboboxCouleurTL4 = interface.get_object("comboboxCouleurTL4")
        self.comboboxCouleurTL5 = interface.get_object("comboboxCouleurTL5")
        
        self.comboboxPositionTL1 = interface.get_object("comboboxPositionTL1")
        self.comboboxPositionTL2 = interface.get_object("comboboxPositionTL2")
        self.comboboxPositionTL3 = interface.get_object("comboboxPositionTL3")
        self.comboboxPositionTL4 = interface.get_object("comboboxPositionTL4")
        self.comboboxPositionTL5 = interface.get_object("comboboxPositionTL5")


        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)

        #Couleur par défaut : noir
        self.comboboxCouleurTL1.set_active(2)
        self.comboboxCouleurTL2.set_active(2)
        self.comboboxCouleurTL3.set_active(2)
        self.comboboxCouleurTL4.set_active(2)
        self.comboboxCouleurTL5.set_active(2)
        
        #Position par défaut : haut
        self.comboboxPositionTL1.set_active(0)
        self.comboboxPositionTL2.set_active(0)
        self.comboboxPositionTL3.set_active(0)
        self.comboboxPositionTL4.set_active(0)
        self.comboboxPositionTL5.set_active(0)
        
        #désactivation
        self.comboboxCouleurTL1.set_sensitive(False)
        self.comboboxPositionTL1.set_sensitive(False)
        self.entryTL1.set_sensitive(False)
        self.entryXTL1.set_sensitive(False)
        self.entryYTL1.set_sensitive(False)
        
        self.comboboxCouleurTL2.set_sensitive(False)
        self.comboboxPositionTL2.set_sensitive(False)
        self.entryTL2.set_sensitive(False)
        self.entryXTL2.set_sensitive(False)
        self.entryYTL2.set_sensitive(False)
        
        self.comboboxCouleurTL3.set_sensitive(False)
        self.comboboxPositionTL3.set_sensitive(False)
        self.entryTL3.set_sensitive(False)
        self.entryXTL3.set_sensitive(False)
        self.entryYTL3.set_sensitive(False)

        self.comboboxCouleurTL4.set_sensitive(False)
        self.comboboxPositionTL4.set_sensitive(False)
        self.entryTL4.set_sensitive(False)
        self.entryXTL4.set_sensitive(False)
        self.entryYTL4.set_sensitive(False)

        self.comboboxCouleurTL5.set_sensitive(False)
        self.comboboxPositionTL5.set_sensitive(False)
        self.entryTL5.set_sensitive(False)
        self.entryXTL5.set_sensitive(False)
        self.entryYTL5.set_sensitive(False)

    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowTL_destroy(self, widget):
        gtk.main_quit()
        #self.windowTL.hide()
        #self.parent.set_active(False)
        
    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codetextelibre(self):
        Texte_Code=""
        if self.checkbuttonTL1.get_active()==True:
                TL=self.entryTL1.get_text()
                TL=traiter_texte(TL)
                XTL=self.entryXTL1.get_text()
                YTL=self.entryYTL1.get_text()
                Couleur=self.comboboxCouleurTL1.get_active_text()
                Position=self.comboboxPositionTL1.get_active_text()
                Texte_Code=Texte_Code+"[\"texte-libre\",["+XTL+","+YTL+"],\""+TL+"\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\"],\n"
                
        #---------------------------2
        if self.checkbuttonTL2.get_active()==True:
                TL=self.entryTL2.get_text()
                TL=traiter_texte(TL)
                XTL=self.entryXTL2.get_text()
                YTL=self.entryYTL2.get_text()
                Couleur=self.comboboxCouleurTL2.get_active_text()
                Position=self.comboboxPositionTL2.get_active_text()
                Texte_Code=Texte_Code+"[\"texte-libre\",["+XTL+","+YTL+"],\""+TL+"\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\"],\n"
                
        #---------------------------3
        if self.checkbuttonTL3.get_active()==True:
                TL=self.entryTL3.get_text()
                TL=traiter_texte(TL)
                XTL=self.entryXTL3.get_text()
                YTL=self.entryYTL3.get_text()
                Couleur=self.comboboxCouleurTL3.get_active_text()
                Position=self.comboboxPositionTL3.get_active_text()
                Texte_Code=Texte_Code+"[\"texte-libre\",["+XTL+","+YTL+"],\""+TL+"\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\"],\n"
                
        #---------------------------4
        if self.checkbuttonTL4.get_active()==True:
                TL=self.entryTL4.get_text()
                TL=traiter_texte(TL)
                XTL=self.entryXTL4.get_text()
                YTL=self.entryYTL4.get_text()
                Couleur=self.comboboxCouleurTL4.get_active_text()
                Position=self.comboboxPositionTL4.get_active_text()
                Texte_Code=Texte_Code+"[\"texte-libre\",["+XTL+","+YTL+"],\""+TL+"\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\"],\n"
                
        #---------------------------5
        if self.checkbuttonTL5.get_active()==True:
                TL=self.entryTL5.get_text()
                TL=traiter_texte(TL)
                XTL=self.entryXTL5.get_text()
                YTL=self.entryYTL5.get_text()
                Couleur=self.comboboxCouleurTL5.get_active_text()
                Position=self.comboboxPositionTL5.get_active_text()
                Texte_Code=Texte_Code+"[\"texte-libre\",["+XTL+","+YTL+"],\""+TL+"\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\"],\n"
                    
        
        
        self.Texte_Libre=Texte_Code
        if self.parent.initialisation==False:
            self.parent.maj_codeprofessor()

    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition des textes
    #-------------------------------------------------------------      
    
    def on_checkbuttonTL1_clicked(self,widget):
        self.maj_codetextelibre()
        if self.checkbuttonTL1.get_active()==True:
            self.entryTL1.set_sensitive(True)
            self.entryXTL1.set_sensitive(True)
            self.entryYTL1.set_sensitive(True)
            self.comboboxCouleurTL1.set_sensitive(True)
            self.comboboxPositionTL1.set_sensitive(True)
        else:
            self.entryTL1.set_sensitive(False)
            self.entryXTL1.set_sensitive(False)
            self.entryYTL1.set_sensitive(False)
            self.comboboxCouleurTL1.set_sensitive(False)
            self.comboboxPositionTL1.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryTL1_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_entryXTL1_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    def on_entryYTL1_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurTL1_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionTL1_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 2
        
    def on_checkbuttonTL2_clicked(self,widget):
        self.maj_codetextelibre()
        if self.checkbuttonTL2.get_active()==True:
            self.entryTL2.set_sensitive(True)
            self.entryXTL2.set_sensitive(True)
            self.entryYTL2.set_sensitive(True)
            self.comboboxCouleurTL2.set_sensitive(True)
            self.comboboxPositionTL2.set_sensitive(True)
        else:
            self.entryTL2.set_sensitive(False)
            self.entryXTL2.set_sensitive(False)
            self.entryYTL2.set_sensitive(False)
            self.comboboxCouleurTL2.set_sensitive(False)
            self.comboboxPositionTL2.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryTL2_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_entryXTL2_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    def on_entryYTL2_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurTL2_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionTL2_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 3
        
    def on_checkbuttonTL3_clicked(self,widget):
        self.maj_codetextelibre()
        if self.checkbuttonTL3.get_active()==True:
            self.entryTL3.set_sensitive(True)
            self.entryXTL3.set_sensitive(True)
            self.entryYTL3.set_sensitive(True)
            self.comboboxCouleurTL3.set_sensitive(True)
            self.comboboxPositionTL3.set_sensitive(True)
        else:
            self.entryTL3.set_sensitive(False)
            self.entryXTL3.set_sensitive(False)
            self.entryYTL3.set_sensitive(False)
            self.comboboxCouleurTL3.set_sensitive(False)
            self.comboboxPositionTL3.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryTL3_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_entryXTL3_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    def on_entryYTL3_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurTL3_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionTL3_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 4
        
    def on_checkbuttonTL4_clicked(self,widget):
        self.maj_codetextelibre()
        if self.checkbuttonTL4.get_active()==True:
            self.entryTL4.set_sensitive(True)
            self.entryXTL4.set_sensitive(True)
            self.entryYTL4.set_sensitive(True)
            self.comboboxCouleurTL4.set_sensitive(True)
            self.comboboxPositionTL4.set_sensitive(True)
        else:
            self.entryTL4.set_sensitive(False)
            self.entryXTL4.set_sensitive(False)
            self.entryYTL4.set_sensitive(False)
            self.comboboxCouleurTL4.set_sensitive(False)
            self.comboboxPositionTL4.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryTL4_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_entryXTL4_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    def on_entryYTL4_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurTL4_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionTL4_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 5
        
    def on_checkbuttonTL5_clicked(self,widget):
        self.maj_codetextelibre()
        if self.checkbuttonTL5.get_active()==True:
            self.entryTL5.set_sensitive(True)
            self.entryXTL5.set_sensitive(True)
            self.entryYTL5.set_sensitive(True)
            self.comboboxCouleurTL5.set_sensitive(True)
            self.comboboxPositionTL5.set_sensitive(True)
        else:
            self.entryTL5.set_sensitive(False)
            self.entryXTL5.set_sensitive(False)
            self.entryYTL5.set_sensitive(False)
            self.comboboxCouleurTL5.set_sensitive(False)
            self.comboboxPositionTL5.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryTL5_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_entryXTL5_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        
    def on_entryYTL5_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurTL5_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionTL5_changed(self,widget):
        self.maj_codetextelibre()
        self.Etat_Compilation=False 
        

                
        

            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Textelibre()
    gtk.main()

