# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files fonction.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *




class Fonction:

    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self,parent):
        self.parent=parent
        interface = gtk.Builder()
        interface.add_from_file('fonction.glade')
        self.windowF=interface.get_object("windowF")
        self.checkbuttonActiver=interface.get_object("checkbuttonActiver")
        self.checkbuttonDF=interface.get_object("checkbuttonDF")
        self.checkbuttonAN=interface.get_object("checkbuttonAN")
        self.checkbuttonGO=interface.get_object("checkbuttonGO")
        self.checkbuttonDO=interface.get_object("checkbuttonDO")
        self.checkbuttonPP1=interface.get_object("checkbuttonPP1")
        self.checkbuttonPP2=interface.get_object("checkbuttonPP2")
        self.checkbuttonTG1=interface.get_object("checkbuttonTG1")
        self.checkbuttonTG2=interface.get_object("checkbuttonTG2")
        self.checkbuttonASC=interface.get_object("checkbuttonASC")
        self.checkbuttonSR=interface.get_object("checkbuttonSR")
        self.entryExpression = interface.get_object("entryExpression")
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryNAN = interface.get_object("entryNAN")
        self.entryXAN = interface.get_object("entryXAN")
        self.entryNPP1 = interface.get_object("entryNPP1")
        self.entryXPP1 = interface.get_object("entryXPP1")
        self.entryNPP2 = interface.get_object("entryNPP2")
        self.entryXPP2 = interface.get_object("entryXPP2")
        self.entryNTG1 = interface.get_object("entryNTG1")
        self.entryXTG1 = interface.get_object("entryXTG1")
        self.entryDTG1 = interface.get_object("entryDTG1")
        self.entryNTG2 = interface.get_object("entryNTG2")
        self.entryXTG2 = interface.get_object("entryXTG2")
        self.entryDTG2 = interface.get_object("entryDTG2")
        self.entryXmASC = interface.get_object("entryXmASC")
        self.entryXMASC = interface.get_object("entryXMASC")
        self.entryXmSR = interface.get_object("entryXmSR")
        self.entryXMSR = interface.get_object("entryXMSR")
        self.entryNBSR = interface.get_object("entryNBSR")
        self.comboboxCouleurF = interface.get_object("comboboxCouleurF")
        self.comboboxCouleurPP1 = interface.get_object("comboboxCouleurPP1")
        self.comboboxCouleurPP2 = interface.get_object("comboboxCouleurPP2")
        self.comboboxCouleurTG1 = interface.get_object("comboboxCouleurTG1")
        self.comboboxCouleurTG2 = interface.get_object("comboboxCouleurTG2")
        self.comboboxCouleurASC = interface.get_object("comboboxCouleurASC")
        self.comboboxCouleurSR = interface.get_object("comboboxCouleurSR")
        self.comboboxPositionAN = interface.get_object("comboboxPositionAN")
        self.comboboxPositionPP1 = interface.get_object("comboboxPositionPP1")
        self.comboboxPositionPP2 = interface.get_object("comboboxPositionPP2")
        self.comboboxPositionTG1 = interface.get_object("comboboxPositionTG1")
        self.comboboxPositionTG2 = interface.get_object("comboboxPositionTG2")
        self.comboboxRemplissageASC = interface.get_object("comboboxRemplissageASC")
        self.comboboxRemplissageSR = interface.get_object("comboboxRemplissageSR")
        self.comboboxRiemannSR = interface.get_object("comboboxRiemannSR")
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)

        #Couleur par défaut :
        self.comboboxCouleurF.set_active(1)
        self.comboboxCouleurPP1.set_active(2)
        self.comboboxCouleurPP2.set_active(2)
        self.comboboxCouleurTG1.set_active(2)
        self.comboboxCouleurTG2.set_active(2)
        self.comboboxCouleurASC.set_active(4)
        self.comboboxCouleurSR.set_active(4)
        
        #Position par défaut : haut
        self.comboboxPositionAN.set_active(0)
        self.comboboxPositionPP1.set_active(0)
        self.comboboxPositionPP2.set_active(0)
        self.comboboxPositionTG1.set_active(0)
        self.comboboxPositionTG2.set_active(0)
        
        #Autres valeurs par défaut
        self.comboboxRemplissageASC.set_active(1)
        self.comboboxRemplissageSR.set_active(1)
        self.comboboxRiemannSR.set_active(0)
        
        #desactivation
        self.entryXmin.set_sensitive(False)
        self.entryXmax.set_sensitive(False)
        self.checkbuttonGO.set_sensitive(False)
        self.checkbuttonDO.set_sensitive(False)
        
        self.entryNAN.set_sensitive(False)
        self.entryXAN.set_sensitive(False)
        self.comboboxPositionAN.set_sensitive(False)
        
        self.entryNPP1.set_sensitive(False)
        self.entryXPP1.set_sensitive(False)
        self.comboboxCouleurPP1.set_sensitive(False)
        self.comboboxPositionPP1.set_sensitive(False)
        
        self.entryNPP2.set_sensitive(False)
        self.entryXPP2.set_sensitive(False)
        self.comboboxCouleurPP2.set_sensitive(False)
        self.comboboxPositionPP2.set_sensitive(False)
        
        self.entryNTG1.set_sensitive(False)
        self.entryXTG1.set_sensitive(False)
        self.entryDTG1.set_sensitive(False)
        self.comboboxCouleurTG1.set_sensitive(False)
        self.comboboxPositionTG1.set_sensitive(False)
        
        self.entryNTG2.set_sensitive(False)
        self.entryXTG2.set_sensitive(False)
        self.entryDTG2.set_sensitive(False)
        self.comboboxCouleurTG2.set_sensitive(False)
        self.comboboxPositionTG2.set_sensitive(False)
        
        self.entryXmASC.set_sensitive(False)
        self.entryXMASC.set_sensitive(False)
        self.comboboxCouleurASC.set_sensitive(False)
        self.comboboxRemplissageASC.set_sensitive(False)
        
        self.entryXmSR.set_sensitive(False)
        self.entryXMSR.set_sensitive(False)
        self.entryNBSR.set_sensitive(False)
        self.comboboxCouleurSR.set_sensitive(False)
        self.comboboxRemplissageSR.set_sensitive(False)
        self.comboboxRiemannSR.set_sensitive(False)

    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowF_destroy(self, widget):
        gtk.main_quit()
        
    #-------------------------------------------------------------
    # Met à jour le code de la fonction
    #-------------------------------------------------------------  
    def maj_codefonction(self):
        Texte_Code=""
        if self.checkbuttonActiver.get_active()==True:
            Expression=self.entryExpression.get_text()
            Xmin=self.entryXmin.get_text()
            Xmax=self.entryXmax.get_text()
            Couleur=self.comboboxCouleurF.get_active_text()
            Couleur=Nom_Couleur(Couleur)
            if self.checkbuttonDF.get_active()==True:
                if self.checkbuttonGO.get_active()==True and self.checkbuttonDO.get_active()==True:
                    Texte_Code=Texte_Code+"["+Expression+",\""+Couleur+"\",["+Xmin+","+Xmax+",\"oo\"]]"
                if self.checkbuttonGO.get_active()==True and self.checkbuttonDO.get_active()==False:
                    Texte_Code=Texte_Code+"["+Expression+",\""+Couleur+"\",["+Xmin+","+Xmax+",\"of\"]]"
                if self.checkbuttonGO.get_active()==False and self.checkbuttonDO.get_active()==True:
                    Texte_Code=Texte_Code+"["+Expression+",\""+Couleur+"\",["+Xmin+","+Xmax+",\"fo\"]]"
                if self.checkbuttonGO.get_active()==False and self.checkbuttonDO.get_active()==False:
                    Texte_Code=Texte_Code+"["+Expression+",\""+Couleur+"\",["+Xmin+","+Xmax+",\"ff\"]]"     
            else:
                Texte_Code=Texte_Code+"["+Expression+",\""+Couleur+"\"]"        
        
        
        self.Texte_Fonction=Texte_Code
        if self.parent.initialisation==False:
            self.parent.maj_codeprofessor()
            
    #-------------------------------------------------------------
    # Met à jour le code des options de la fonction
    #-------------------------------------------------------------  
    def maj_codeoptions(self):
        Texte_Code=""
        if self.checkbuttonActiver.get_active()==True:
            if self.checkbuttonAN.get_active()==True:
                Numero=self.Numero
                NAN=self.entryNAN.get_text()
                NAN=traiter_texte(NAN)
                XAN=self.entryXAN.get_text()
                XAN=traiter_texte(XAN)
                Couleur=self.comboboxCouleurF.get_active_text()
                Couleur=Nom_Couleur(Couleur)
                Position=self.comboboxPositionAN.get_active_text()
                Position=Nom_Position(Position)
                Texte_Code=Texte_Code+"[\"texte-courbe\","+Numero+","+XAN+",\"$"+NAN+"$\",\""+Position+"\",\""+Couleur+"\"],\n"
            if self.checkbuttonPP1.get_active()==True:
                Numero=self.Numero
                NPP1=self.entryNPP1.get_text()
                NPP1=traiter_texte(NPP1)
                XPP1=self.entryXPP1.get_text()
                XPP1=traiter_texte(XPP1)
                CouleurPP1=self.comboboxCouleurPP1.get_active_text()
                CouleurPP1=Nom_Couleur(CouleurPP1)
                PositionPP1=self.comboboxPositionPP1.get_active_text()
                PositionPP1=Nom_Position(PositionPP1)
                Texte_Code=Texte_Code+"[\"point-courbe\","+Numero+","+XPP1+",\"$"+NPP1+"$\",\""+PositionPP1+"\",\""+CouleurPP1+"\"],\n"
            
            if self.checkbuttonPP2.get_active()==True:
                Numero=self.Numero
                NPP2=self.entryNPP2.get_text()
                NPP2=traiter_texte(NPP2)
                XPP2=self.entryXPP2.get_text()
                XPP2=traiter_texte(XPP2)
                CouleurPP2=self.comboboxCouleurPP2.get_active_text()
                CouleurPP2=Nom_Couleur(CouleurPP2)
                PositionPP2=self.comboboxPositionPP2.get_active_text()
                PositionPP2=Nom_Position(PositionPP2)
                Texte_Code=Texte_Code+"[\"point-courbe\","+Numero+","+XPP2+",\"$"+NPP2+"$\",\""+PositionPP2+"\",\""+CouleurPP2+"\"],\n"
                
            if self.checkbuttonTG1.get_active()==True:
                Numero=self.Numero
                NTG1=self.entryNTG1.get_text()
                NTG1=traiter_texte(NTG1)
                XTG1=self.entryXTG1.get_text()
                XTG1=traiter_texte(XTG1)
                DTG1=self.entryDTG1.get_text()
                DTG1=traiter_texte(DTG1)
                CouleurTG1=self.comboboxCouleurTG1.get_active_text()
                CouleurTG1=Nom_Couleur(CouleurTG1)
                PositionTG1=self.comboboxPositionTG1.get_active_text()
                PositionTG1=Nom_Position(PositionTG1)
                Texte_Code=Texte_Code+"[\"tangente\","+Numero+","+XTG1+",\"$"+NTG1+"$\",\""+PositionTG1+"\",\""+CouleurTG1+"\","+DTG1+"],\n"
                
            if self.checkbuttonTG2.get_active()==True:
                Numero=self.Numero
                NTG2=self.entryNTG2.get_text()
                NTG2=traiter_texte(NTG2)
                XTG2=self.entryXTG2.get_text()
                XTG2=traiter_texte(XTG2)
                DTG2=self.entryDTG2.get_text()
                DTG2=traiter_texte(DTG2)
                CouleurTG2=self.comboboxCouleurTG2.get_active_text()
                CouleurTG2=Nom_Couleur(CouleurTG2)
                PositionTG2=self.comboboxPositionTG2.get_active_text()
                PositionTG2=Nom_Position(PositionTG2)
                Texte_Code=Texte_Code+"[\"tangente\","+Numero+","+XTG2+",\"$"+NTG2+"$\",\""+PositionTG2+"\",\""+CouleurTG2+"\","+DTG2+"],\n"
                
            if self.checkbuttonASC.get_active()==True:
                Numero=self.Numero
                XmASC=self.entryXmASC.get_text()
                XmASC=traiter_texte(XmASC)
                XMASC=self.entryXMASC.get_text()
                XMASC=traiter_texte(XMASC)
                CouleurASC=self.comboboxCouleurASC.get_active_text()
                CouleurASC=Nom_Couleur(CouleurASC)
                RemplissageASC=self.comboboxRemplissageASC.get_active_text()
                if RemplissageASC=="Hachuré":
                    Texte_Code=Texte_Code+"[\"aire-sous-courbe\","+Numero+","+XmASC+","+XMASC+",\""+CouleurASC+"\",\"hachure\"],\n"
                else:
                    Texte_Code=Texte_Code+"[\"aire-sous-courbe\","+Numero+","+XmASC+","+XMASC+",\""+CouleurASC+"\"],\n"
                    
            if self.checkbuttonSR.get_active()==True:
                Numero=self.Numero
                XmSR=self.entryXmSR.get_text()
                XmSR=traiter_texte(XmSR)
                XMSR=self.entryXMSR.get_text()
                XMSR=traiter_texte(XMSR)
                NBSR=self.entryNBSR.get_text()
                NBSR=traiter_texte(NBSR)
                CouleurSR=self.comboboxCouleurSR.get_active_text()
                CouleurSR=Nom_Couleur(CouleurSR)
                RemplissageSR=self.comboboxRemplissageSR.get_active_text()
                RiemannSR=self.comboboxRiemannSR.get_active_text()
                if RiemannSR=="Minimum":
                    Option_Riemann="min"
                elif RiemannSR=="Maximum":
                    Option_Riemann="max"    
                else:
                    Option_Riemann="centre" 
                if RemplissageSR=="Hachuré":
                    Texte_Code=Texte_Code+"[\"riemann\","+Numero+","+XmSR+","+XMSR+","+NBSR+",\""+Option_Riemann+"\",\""+CouleurSR+"\",\"hachure\"],\n"
                else:
                    Texte_Code=Texte_Code+"[\"riemann\","+Numero+","+XmSR+","+XMSR+","+NBSR+",\""+Option_Riemann+"\",\""+CouleurSR+"\"],\n"
                            
                    
        
        self.Texte_Options=Texte_Code
        if self.parent.initialisation==False:
            self.parent.maj_codeprofessor()     
            

    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition des textes
    #-------------------------------------------------------------      
    def on_checkbuttonActiver_clicked(self,widget):
        self.maj_codefonction()
        self.Etat_Compilation=False
        if self.checkbuttonActiver.get_active()==False:
            self.windowF.hide()
            if self.Numero=="2":
                self.parent.checkbuttonF2.set_active(False)
            if self.Numero=="3":
                self.parent.checkbuttonF3.set_active(False)
            if self.Numero=="4":
                self.parent.checkbuttonF4.set_active(False)
        
    def on_entryExpression_changed(self,widget):
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryXmin_changed(self,widget):
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXmax_changed(self,widget):
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurF_changed(self,widget):
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_checkbuttonDF_clicked(self,widget):
        if self.checkbuttonDF.get_active()==True:
            self.entryXmin.set_sensitive(True)
            self.entryXmax.set_sensitive(True)
            self.checkbuttonGO.set_sensitive(True)
            self.checkbuttonDO.set_sensitive(True)
        else:
            self.entryXmin.set_sensitive(False)
            self.entryXmax.set_sensitive(False)
            self.checkbuttonGO.set_sensitive(False)
            self.checkbuttonDO.set_sensitive(False)
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_checkbuttonGO_clicked(self,widget):
        self.maj_codefonction()
        self.Etat_Compilation=False 
            
    def on_checkbuttonDO_clicked(self,widget):
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    #-------------------------------------------------------------
    # Mise à jour après des changements dans les options
    #-------------------------------------------------------------  
    
    #-----------------------------------------
    def on_checkbuttonAN_clicked(self,widget):
        if self.checkbuttonAN.get_active()==True:
            self.entryNAN.set_sensitive(True)
            self.entryXAN.set_sensitive(True)
            self.comboboxPositionAN.set_sensitive(True)
        else:
            self.entryNAN.set_sensitive(False)
            self.entryXAN.set_sensitive(False)
            self.comboboxPositionAN.set_sensitive(False)
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
            
    def on_entryNAN_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXAN_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxPositionAN_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
            
    #-----------------------------------------              
    def on_checkbuttonPP1_clicked(self,widget):
        if self.checkbuttonPP1.get_active()==True:
            self.entryNPP1.set_sensitive(True)
            self.entryXPP1.set_sensitive(True)
            self.comboboxCouleurPP1.set_sensitive(True)
            self.comboboxPositionPP1.set_sensitive(True)
        else:
            self.entryNPP1.set_sensitive(False)
            self.entryXPP1.set_sensitive(False)
            self.comboboxCouleurPP1.set_sensitive(False)
            self.comboboxPositionPP1.set_sensitive(False)
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryNPP1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXPP1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPP1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxPositionPP1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
    
    #-----------------------------------------  
    def on_checkbuttonPP2_clicked(self,widget):
        if self.checkbuttonPP2.get_active()==True:
            self.entryNPP2.set_sensitive(True)
            self.entryXPP2.set_sensitive(True)
            self.comboboxCouleurPP2.set_sensitive(True)
            self.comboboxPositionPP2.set_sensitive(True)
        else:
            self.entryNPP2.set_sensitive(False)
            self.entryXPP2.set_sensitive(False)
            self.comboboxCouleurPP2.set_sensitive(False)
            self.comboboxPositionPP2.set_sensitive(False)
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryNPP2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXPP2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPP2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxPositionPP2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False         
    
    #-----------------------------------------  
    def on_checkbuttonTG1_clicked(self,widget):
        if self.checkbuttonTG1.get_active()==True:
            self.entryNTG1.set_sensitive(True)
            self.entryXTG1.set_sensitive(True)
            self.entryDTG1.set_sensitive(True)
            self.comboboxCouleurTG1.set_sensitive(True)
            self.comboboxPositionTG1.set_sensitive(True)
        else:
            self.entryNTG1.set_sensitive(False)
            self.entryXTG1.set_sensitive(False)
            self.entryDTG1.set_sensitive(False)
            self.comboboxCouleurTG1.set_sensitive(False)
            self.comboboxPositionTG1.set_sensitive(False)
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryNTG1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXTG1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryDTG1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_comboboxCouleurTG1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxPositionTG1_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
    
    #-----------------------------------------  
    def on_checkbuttonTG2_clicked(self,widget):
        if self.checkbuttonTG2.get_active()==True:
            self.entryNTG2.set_sensitive(True)
            self.entryXTG2.set_sensitive(True)
            self.entryDTG2.set_sensitive(True)
            self.comboboxCouleurTG2.set_sensitive(True)
            self.comboboxPositionTG2.set_sensitive(True)
        else:
            self.entryNTG2.set_sensitive(False)
            self.entryXTG2.set_sensitive(False)
            self.entryDTG2.set_sensitive(False)
            self.comboboxCouleurTG2.set_sensitive(False)
            self.comboboxPositionTG2.set_sensitive(False)
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryNTG2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXTG2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryDTG2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_comboboxCouleurTG2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxPositionTG2_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    #-----------------------------------------
    def on_checkbuttonASC_clicked(self,widget):
        if self.checkbuttonASC.get_active()==True:
            self.entryXmASC.set_sensitive(True)
            self.entryXMASC.set_sensitive(True)
            self.comboboxCouleurASC.set_sensitive(True)
            self.comboboxRemplissageASC.set_sensitive(True)
        else:
            self.entryXmASC.set_sensitive(False)
            self.entryXMASC.set_sensitive(False)
            self.comboboxCouleurASC.set_sensitive(False)
            self.comboboxRemplissageASC.set_sensitive(False)
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryXmASC_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXMASC_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
            
    def on_comboboxCouleurASC_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxRemplissageASC_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    #-----------------------------------------
    def on_checkbuttonSR_clicked(self,widget):
        if self.checkbuttonSR.get_active()==True:
            self.entryXmSR.set_sensitive(True)
            self.entryXMSR.set_sensitive(True)
            self.entryNBSR.set_sensitive(True)
            self.comboboxCouleurSR.set_sensitive(True)
            self.comboboxRemplissageSR.set_sensitive(True)
            self.comboboxRiemannSR.set_sensitive(True)
        else:
            self.entryXmSR.set_sensitive(False)
            self.entryXMSR.set_sensitive(False)
            self.entryNBSR.set_sensitive(False)
            self.comboboxCouleurSR.set_sensitive(False)
            self.comboboxRemplissageSR.set_sensitive(False)
            self.comboboxRiemannSR.set_sensitive(False)
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryXmSR_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_entryXMSR_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_entryNBSR_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_comboboxCouleurSR_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False
        
    def on_comboboxRemplissageSR_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False 
        
    def on_comboboxRiemannSR_changed(self,widget):
        self.maj_codeoptions()
        self.maj_codefonction()
        self.Etat_Compilation=False             
            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Fonction()
    gtk.main()

