# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files grapheoriente.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
sys.path.append("../Supplements/Pro-graphes/")
from supp_grapheoriente import *





class Grapheoriente:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('grapheoriente.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.radiobuttonNB4 = interface.get_object("radiobuttonNB4")
        self.radiobuttonNB5 = interface.get_object("radiobuttonNB5")
        self.radiobuttonNB6 = interface.get_object("radiobuttonNB6")
        self.radiobuttonNB7 = interface.get_object("radiobuttonNB7")
        self.radiobuttonNB8 = interface.get_object("radiobuttonNB8")
        self.entryListeSommets = interface.get_object("entryListeSommets")
        self.entryPositions = interface.get_object("entryPositions")
        self.entryEchelle = interface.get_object("entryEchelle")
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.textviewMatrice = interface.get_object("textviewMatrice")
        self.textbufferMatrice = interface.get_object("textbufferMatrice")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.checkbuttonPositions = interface.get_object("checkbuttonPositions")
        self.checkbuttonEchelle = interface.get_object("checkbuttonEchelle")
        self.checkbuttonPondere = interface.get_object("checkbuttonPondere")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")

        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        #désactivation
        self.entryPositions.set_sensitive(False)
        self.entryEchelle.set_sensitive(False)

        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowGrapheoriente_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-graphedessin}{1}\n"
        ListeSommets=self.entryListeSommets.get_text()
        ListeSommets=ListeSommets.replace('\\','@')
        text_buffer=self.textbufferMatrice
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Matrice=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        Texte_Code=Texte_Code+"["+ListeSommets+"], // sommets \n"
        Texte_Code=Texte_Code+"[ //----------------- debut matrice\n"
        Texte_Code=Texte_Code+Matrice
        Texte_Code=Texte_Code+"\n],//----------------- fin matrice\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-graphedessin}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
    def on_entryListeSommets_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_textbufferMatrice_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False

    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        
    def on_radiobuttonNB4_clicked(self,widget):
        #sommets
        self.entryListeSommets.set_text("\"A\",\"B\",\"C\",\"D\"")
        #matrice
        Texte_Matrice="[0,1,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,1],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,1,1,0]"
        text_view=self.textviewMatrice
        ecrire_texte_textview(Texte_Matrice,text_view)
        #Positions
        self.entryPositions.set_text("[-1,2],[4,3],[4,-2],[0,-3]")
        #mise à jour
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_radiobuttonNB5_clicked(self,widget):
        #sommets
        self.entryListeSommets.set_text("\"A\",\"B\",\"C\",\"D\",\"E\"")
        Texte_Matrice="[0,1,0,1,0],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,1,1],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0],\n"
        Texte_Matrice=Texte_Matrice+"[1,1,1,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0]"
        #matrice
        text_view=self.textviewMatrice
        ecrire_texte_textview(Texte_Matrice,text_view)
        #Positions
        self.entryPositions.set_text("[-1,2],[4,3],[4,-2],[0,-3],[-3,-1]")
        #mise à jour
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_radiobuttonNB6_clicked(self,widget):
        #sommets
        self.entryListeSommets.set_text("\"A\",\"B\",\"C\",\"D\",\"E\",\"F\"")
        Texte_Matrice="[0,1,0,1,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,1,1,0],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,1,1,0,1,0],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,0,1,0]"
        #matrice
        text_view=self.textviewMatrice
        ecrire_texte_textview(Texte_Matrice,text_view)
        #Positions
        self.entryPositions.set_text("[-1,2],[4,3],[4,-2],[0,-3],[-3,-1],[2,0]")
        #mise à jour
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_radiobuttonNB7_clicked(self,widget):
        #sommets
        self.entryListeSommets.set_text("\"A\",\"B\",\"C\",\"D\",\"E\",\"F\",\"G\"")
        Texte_Matrice="[0,1,0,1,0,1,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,1,1,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0,1,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,1,1,0,1,0,0],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0,1,0],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,0,1,0,0],\n"
        Texte_Matrice=Texte_Matrice+"[1,1,1,0,0,0,0]"
        #matrice
        text_view=self.textviewMatrice
        ecrire_texte_textview(Texte_Matrice,text_view)
        #Positions
        self.entryPositions.set_text("[-1,2],[4,3],[4,-2],[0,-3],[-3,-1],[2,0],[3,1]")
        #mise à jour
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_radiobuttonNB8_clicked(self,widget):
        #sommets
        self.entryListeSommets.set_text("\"A\",\"B\",\"C\",\"D\",\"E\",\"F\",\"G\",\"H\"")
        Texte_Matrice="[0,1,0,1,0,1,1,0],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,1,1,0,1,0],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0,1,1,1],\n"
        Texte_Matrice=Texte_Matrice+"[1,1,1,0,1,0,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[0,1,0,1,0,1,0,0],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,0,1,0,0,0],\n"
        Texte_Matrice=Texte_Matrice+"[1,0,1,0,1,0,0,1],\n"
        Texte_Matrice=Texte_Matrice+"[0,0,1,1,0,0,1,0]"
        #matrice
        text_view=self.textviewMatrice
        ecrire_texte_textview(Texte_Matrice,text_view)
        #Positions
        self.entryPositions.set_text("[-1,2],[4,3],[4,-2],[0,-3],[-3,-1],[2,0],[3,1],[3,2]")
        #mise à jour
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        


    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-graphes}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-graphes}")       
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
           
        if self.checkbuttonPondere.get_active()==True :
            Options=Options+"[\"type-graphe\",[\"oriente\",\"pondere\"]],\n" 
        else:
            Options=Options+"[\"type-graphe\",[\"oriente\"]],\n" 
            
        if self.checkbuttonPositions.get_active()==True :
            Positions=self.entryPositions.get_text()
            Options=Options+"[\"position-noeuds\",["+Positions+"]],\n"  
            
        if self.checkbuttonEchelle.get_active()==True :
            Echelle=self.entryEchelle.get_text()
            Options=Options+"[\"echelle\","+Echelle+"],\n"  
                
       
        Options=Options+self.TL.Texte_Libre
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_checkbuttonColoriage_clicked(self,widget):
        if self.checkbuttonColoriage.get_active()==False :
            self.entryColoriage.set_sensitive(False)
        else :
            self.entryColoriage.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_checkbuttonPositions_clicked(self,widget):
        if self.checkbuttonPositions.get_active()==False :
            self.entryPositions.set_sensitive(False)
        else :
            self.entryPositions.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False 
        
    def on_checkbuttonEchelle_clicked(self,widget):
        if self.checkbuttonEchelle.get_active()==False :
            self.entryEchelle.set_sensitive(False)
        else :
            self.entryEchelle.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False     
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryColoriage_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryPositions_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False     
        
    def on_entryEchelle_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_checkbuttonPondere_clicked(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False     
        
    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-graphes}")   
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","graphedessin1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-graphes}")   
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","graphedessin1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","graphedessin1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","graphedessin1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","graphedessin1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","graphedessin1",self.Etat_Compilation)          


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Grapheoriente()
    gtk.main()

