# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files Tableval.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *

sys.path.append("../Divers/")
from pro_divers import *
sys.path.append("../Supplements/Pro-tableval/")
from supp_tableval import *




class Tableval:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('Tableval.glade')

        self.entryNomVariable = interface.get_object("entryNomVariable")
        self.entryNomFonction = interface.get_object("entryNomFonction")
        self.entryFonction = interface.get_object("entryFonction")
        self.radiobuttonAuto = interface.get_object("radiobuttonAuto")
        self.radiobuttonManuel = interface.get_object("radiobuttonManuel")      
        self.radiobuttonExact = interface.get_object("radiobuttonExact")
        self.radiobuttonArrondi = interface.get_object("radiobuttonArrondi")
        self.radiobuttonVide = interface.get_object("radiobuttonVide")        
        self.radiobuttonManuel = interface.get_object("radiobuttonManuel")
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryPas = interface.get_object("entryPas")
        self.entryListeValeurs = interface.get_object("entryListeValeurs")
        self.entryDecimales = interface.get_object("entryDecimales")

        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")

        
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        

        
        self.entryNomVariable.grab_focus()
        self.entryListeValeurs.set_sensitive(False)
        self.entryDecimales.set_sensitive(False)

    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowTableval_destroy(self, widget):
        gtk.main_quit()
        
    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        
        NomVariable=self.entryNomVariable.get_text()
        NomVariable=NomVariable.replace('\\','@')
        
        NomFonction=self.entryNomFonction.get_text()
        NomFonction=NomFonction.replace('\\','@')
        
        Fonction=self.entryFonction.get_text()
        
        Xmin=self.entryXmin.get_text()
        Xmax=self.entryXmax.get_text()
        Pas=self.entryPas.get_text()
        
        ListeValeurs=self.entryListeValeurs.get_text()
        Decimales=self.entryDecimales.get_text()

        
        #-------------- code des valeurs
        if self.radiobuttonAuto.get_active()==True: 
            Texte_valeurs="[\"auto\","+Xmin+","+Xmax+","+Pas+"],\n"
        else :
            Texte_valeurs="[\"manuel\","+ListeValeurs+"],\n"
            
        #-------------- code des valeurs
        if self.radiobuttonExact.get_active()==True: 
            Texte_images="[\"exact\"]\n"
        elif self.radiobuttonArrondi.get_active()==True: 
            Texte_images="[\"arrondi\","+Decimales+"]\n"
        else :
            Texte_images="[\"vide\",\"-\"]\n"
        
        
        Texte_Code=""
        #--------------Code principal : Tableval
        Texte_Code=Texte_Code+"\\begin{pro-tableval}{1}\n"
        Texte_Code=Texte_Code+"[\n"
        Texte_Code=Texte_Code+"[\""+NomVariable+"\",\""+NomFonction+"\",\n"
        Texte_Code=Texte_Code+Fonction+"\n"
        Texte_Code=Texte_Code+"],\n"
        Texte_Code=Texte_Code+Texte_valeurs
        Texte_Code=Texte_Code+Texte_images
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"\\end{pro-tableval}"
        ecrire_texte_textview(Texte_Code,text_view)
            



    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition du tableau
    #-------------------------------------------------------------   
    
    def on_entryNomVariable_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
       
    def on_entryNomFonction_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False

        
    def on_entryFonction_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
       
    def on_entryXmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False

        
    def on_entryPas_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False    
        
        
    def on_entryListeValeurs_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False  
        
    def on_entryDecimales_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False   
        
    def on_radiobuttonAuto_clicked(self,widget):
        self.entryXmin.set_sensitive(True)
        self.entryXmax.set_sensitive(True)
        self.entryPas.set_sensitive(True)      
        self.entryListeValeurs.set_sensitive(False)
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_radiobuttonManuel_clicked(self,widget):
        self.entryXmin.set_sensitive(False)
        self.entryXmax.set_sensitive(False)
        self.entryPas.set_sensitive(False)      
        self.entryListeValeurs.set_sensitive(True)
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_radiobuttonExact_clicked(self,widget):
        self.entryDecimales.set_sensitive(False)
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_radiobuttonArrondi_clicked(self,widget):
        self.entryDecimales.set_sensitive(True)
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False     
           
    def on_radiobuttonVide_clicked(self,widget):
        self.entryDecimales.set_sensitive(False)
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 


    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        ecrire_enteteprofessor("\\usepackage[xcas]{pro-courbes}")    
        compiler("mp")
        self.Etat_Compilation=True
        afficher_tableval()
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeTex_clicked(self,widget):
        afficher_codeTex(self.Etat_Compilation)




            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Tableval()
    gtk.main()

