# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files ProfessorWindows.py.


import pygtk
pygtk.require("2.0")
import gtk	

import os
import sys




class Professor:

    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('Professor.glade')
        
        self.comboboxC = interface.get_object("comboboxC")
        self.comboboxTV = interface.get_object("comboboxTV")
        self.comboboxTS = interface.get_object("comboboxTS")
        self.comboboxCR = interface.get_object("comboboxCR")
        self.comboboxSU = interface.get_object("comboboxSU")
        self.comboboxGR = interface.get_object("comboboxGR")
        self.comboboxAP = interface.get_object("comboboxAP")
        self.comboboxS1 = interface.get_object("comboboxS1")
        self.comboboxS2 = interface.get_object("comboboxS2")
        self.comboboxS3 = interface.get_object("comboboxS3")
        self.imageExemple = interface.get_object("imageExemple")
        
        #cachés
        self.comboboxTV.show()
        self.comboboxTS.hide()
        self.comboboxCR.hide()
        self.comboboxSU.hide()
        self.comboboxGR.hide()
        self.comboboxAP.hide()
        self.comboboxS1.hide()
        self.comboboxS2.hide()
        self.comboboxS3.hide()
        
        #valeurs par défaut
        self.comboboxC.set_active(0)
        self.comboboxTV.set_active(0)
        

        interface.connect_signals(self)
        
        self.maj_professor()    

        
    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowProfessor_destroy(self, widget):
        gtk.main_quit()


    #-------------------------------------------------------------
    # Construction des tableaux de variations
    #-------------------------------------------------------------  
    def maj_professor(self):
        Categorie=self.comboboxC.get_active_text()
        #--------------------------------------
        if Categorie=="Tableaux de variations":
            SCategorie=self.comboboxTV.get_active_text()
            if SCategorie=="Tableau de variations simple":
                self.imageExemple.set_from_file("Images/Pro-tablor/TV.png")
                self.Texte_Compilation="Pro-tablor\TV.bat &"
            if SCategorie=="Tableau de variations avec zone interdite":
                self.imageExemple.set_from_file("Images/Pro-tablor/TVZ.png")
                self.Texte_Compilation="Pro-tablor\TVZ.bat &"
            if SCategorie=="Tableau de variations manuel":
                self.imageExemple.set_from_file("Images/Pro-tablor/TVS.png")
                self.Texte_Compilation="Pro-tablor\TVS.bat &"
            
        #--------------------------------------
        if Categorie=="Tableaux de signes":
            SCategorie=self.comboboxTS.get_active_text()
            if SCategorie=="Tableau de signes d'un produit":
                self.imageExemple.set_from_file("Images/Pro-tablor/TS.png")
                self.Texte_Compilation="Pro-tablor\TS.bat &"
            if SCategorie=="Tableau de signes d'un quotient":
                self.imageExemple.set_from_file("Images/Pro-tablor/TSQ.png")
                self.Texte_Compilation="Pro-tablor\TSQ.bat &"
            if SCategorie=="Tableau de signes d'une expression":
                self.imageExemple.set_from_file("Images/Pro-tablor/TSC.png")
                self.Texte_Compilation="Pro-tablor\TSC.bat &"
                
        #--------------------------------------
        if Categorie=="Courbes / Repères":
            SCategorie=self.comboboxCR.get_active_text()
            if SCategorie=="Courbes de fonctions":
                self.imageExemple.set_from_file("Images/Pro-courbes/courbemulti.png")
                self.Texte_Compilation="Pro-courbes\courbemulti.bat &"
            if SCategorie=="Courbes de fonctions (repère semi-logarithmique)":
                self.imageExemple.set_from_file("Images/Pro-courbes/courbesemilog.png")
                self.Texte_Compilation="Pro-courbes\courbesemilog.bat &"
            if SCategorie=="Courbes de Bézier":
                self.imageExemple.set_from_file("Images/Pro-courbes/courbebezier.png")
                self.Texte_Compilation="Pro-courbes\courbebezier.bat &"
            if SCategorie=="Repère":
                self.imageExemple.set_from_file("Images/Pro-courbes/repere.png")
                self.Texte_Compilation="Pro-courbes\repere.bat &"   
        
        #--------------------------------------
        if Categorie=="Suites":
            SCategorie=self.comboboxSU.get_active_text()
            if SCategorie=="Suite définie par son terme général":
                self.imageExemple.set_from_file("Images/Pro-suites/suitefn.png")
                self.Texte_Compilation="Pro-suites\suitefn.bat &"
            if SCategorie=="Suite définie par récurrence":
                self.imageExemple.set_from_file("Images/Pro-suites/suiterec.png")
                self.Texte_Compilation="Pro-suites\suiterec.bat &"

        
        #--------------------------------------
        if Categorie=="Graphes":
            SCategorie=self.comboboxGR.get_active_text()
            if SCategorie=="Graphe probabiliste":
                self.imageExemple.set_from_file("Images/Pro-graghes/grapheproba.png")
                self.Texte_Compilation="Pro-graphes\grapheproba.bat &"
            if SCategorie=="Graphe non orienté":
                self.imageExemple.set_from_file("Images/Pro-graghes/graphesimple.png")
                self.Texte_Compilation="Pro-graphes\graphesimple.bat &"
            if SCategorie=="Graphe orienté":
                self.imageExemple.set_from_file("Images/Pro-graghes/grapheoriente.png")
                self.Texte_Compilation="Pro-graphes\grapheoriente.bat &"
        
        #--------------------------------------
        if Categorie=="Arbre de probabilités":
            SCategorie=self.comboboxAP.get_active_text()
            if SCategorie=="Arbre 2x2":
                self.imageExemple.set_from_file("Images/Pro-probas/arbre22.png")
                self.Texte_Compilation="Pro-probas\\arbre22.bat &"
            if SCategorie=="Arbre 2x3":
                self.imageExemple.set_from_file("Images/Pro-probas/arbre23.png")
                self.Texte_Compilation="Pro-probas\\arbre23.bat &"
            if SCategorie=="Arbre 3x2":
                self.imageExemple.set_from_file("Images/Pro-probas/arbre32.png")
                self.Texte_Compilation="Pro-probas\\arbre32.bat &"
            if SCategorie=="Schéma de Bernoulli":
                self.imageExemple.set_from_file("Images/Pro-probas/bernoulli.png")
                self.Texte_Compilation="Pro-probas\\bernoulli.bat &"    
        
        #--------------------------------------
        if Categorie=="Diagrammes statistiques (une variable)":
            SCategorie=self.comboboxS1.get_active_text()
            if SCategorie=="Boîte à moustaches":
                self.imageExemple.set_from_file("Images/Pro-1varstat/moustache.png")
                self.Texte_Compilation="Pro-1varstat\moustache.bat &"
            if SCategorie=="Diagramme en bâtons":
                self.imageExemple.set_from_file("Images/Pro-1varstat/batons.png")
                self.Texte_Compilation="Pro-1varstat\\batons.bat &"
            if SCategorie=="Lissage par moyennes mobiles":
                self.imageExemple.set_from_file("Images/Pro-1varstat/lissage.png")
                self.Texte_Compilation="Pro-1varstat\lissage.bat &"
            if SCategorie=="Polygone des fréquenques cumulées croissantes":
                self.imageExemple.set_from_file("Images/Pro-1varstat/cumul.png")
                self.Texte_Compilation="Pro-1varstat\cumul.bat &"   
        
        #--------------------------------------
        if Categorie=="Diagrammes statistiques (deux variables)":
            SCategorie=self.comboboxS2.get_active_text()
            if SCategorie=="Nuage de points et droite de régression":
                self.imageExemple.set_from_file("Images/Pro-2varstat/nuage.png")
                self.Texte_Compilation="Pro-2varstat\\nuage.bat &"
        
        #--------------------------------------
        if Categorie=="Diagrammes statistiques (divers)":
            SCategorie=self.comboboxS3.get_active_text()
            if SCategorie=="Diagramme circulaire":
                self.imageExemple.set_from_file("Images/Pro-statdiv/camembert.png")
                self.Texte_Compilation="Pro-statdiv\camembert.bat &"
            if SCategorie=="Diagramme semi-circulaire":
                self.imageExemple.set_from_file("Images/Pro-statdiv/micamembert.png")
                self.Texte_Compilation="Pro-statdiv\micamembert.bat &"
            if SCategorie=="Diagramme en bâtons (avec labels)":
                self.imageExemple.set_from_file("Images/Pro-statdiv/batonslabel.png")
                self.Texte_Compilation="Pro-statdiv\\batonslabel.bat &"
            if SCategorie=="Histogramme":
                self.imageExemple.set_from_file("Images/Pro-statdiv/histogramme.png")
                self.Texte_Compilation="Pro-statdiv\histogramme.bat &"  
            if SCategorie=="Diagramme des températures":
                self.imageExemple.set_from_file("Images/Pro-statdiv/temperatures.png")
                self.Texte_Compilation="Pro-statdiv\\temperatures.bat &"    
        
        
        
        
        
        
        
    #-------------------------------------------------------------
    # Construction des tableaux de variations
    #-------------------------------------------------------------          
    def on_comboboxC_changed(self,widget):  
        Categorie=self.comboboxC.get_active_text()
        if Categorie=="Tableaux de variations":
            self.comboboxTV.show()
            self.comboboxTV.set_active(0)
            self.comboboxTS.hide()
            self.comboboxCR.hide()
            self.comboboxSU.hide()
            self.comboboxGR.hide()
            self.comboboxAP.hide()
            self.comboboxS1.hide()
            self.comboboxS2.hide()
            self.comboboxS3.hide()
        if Categorie=="Tableaux de signes":
            self.comboboxTV.hide()
            self.comboboxTS.show()
            self.comboboxTS.set_active(0)
            self.comboboxCR.hide()
            self.comboboxSU.hide()
            self.comboboxGR.hide()
            self.comboboxAP.hide()
            self.comboboxS1.hide()
            self.comboboxS2.hide()
            self.comboboxS3.hide()
        if Categorie=="Courbes / Repères":
            self.comboboxTV.hide()
            self.comboboxTS.hide()
            self.comboboxCR.show()
            self.comboboxCR.set_active(0)
            self.comboboxSU.hide()
            self.comboboxGR.hide()
            self.comboboxAP.hide()
            self.comboboxS1.hide()
            self.comboboxS2.hide()
            self.comboboxS3.hide()
        if Categorie=="Suites":
            self.comboboxTV.hide()
            self.comboboxTS.hide()
            self.comboboxCR.hide()
            self.comboboxSU.show()
            self.comboboxSU.set_active(0)
            self.comboboxGR.hide()
            self.comboboxAP.hide()
            self.comboboxS1.hide()
            self.comboboxS2.hide()
            self.comboboxS3.hide()
        if Categorie=="Graphes":
            self.comboboxTV.hide()
            self.comboboxTS.hide()
            self.comboboxCR.hide()
            self.comboboxSU.hide()
            self.comboboxGR.show()
            self.comboboxGR.set_active(0)
            self.comboboxAP.hide()
            self.comboboxS1.hide()
            self.comboboxS2.hide()
            self.comboboxS3.hide()
        if Categorie=="Arbre de probabilités":
            self.comboboxTV.hide()
            self.comboboxTS.hide()
            self.comboboxCR.hide()
            self.comboboxGR.hide()
            self.comboboxAP.show()
            self.comboboxAP.set_active(0)
            self.comboboxS1.hide()
            self.comboboxS2.hide()
            self.comboboxS3.hide()
        if Categorie=="Diagrammes statistiques (une variable)":
            self.comboboxTV.hide()
            self.comboboxTS.hide()
            self.comboboxCR.hide()
            self.comboboxSU.hide()
            self.comboboxGR.hide()
            self.comboboxAP.hide()
            self.comboboxS1.show()
            self.comboboxS1.set_active(0)
            self.comboboxS2.hide()
            self.comboboxS3.hide()
        if Categorie=="Diagrammes statistiques (deux variables)":
            self.comboboxTV.hide()
            self.comboboxTS.hide()
            self.comboboxCR.hide()
            self.comboboxSU.hide()
            self.comboboxGR.hide()
            self.comboboxAP.hide()
            self.comboboxS1.hide()
            self.comboboxS2.show()
            self.comboboxS2.set_active(0)
            self.comboboxS3.hide()
        if Categorie=="Diagrammes statistiques (divers)":
            self.comboboxTV.hide()
            self.comboboxTS.hide()
            self.comboboxCR.hide()
            self.comboboxSU.hide()
            self.comboboxGR.hide()
            self.comboboxAP.hide()
            self.comboboxS1.hide()
            self.comboboxS2.hide()
            self.comboboxS3.show()
            self.comboboxS3.set_active(0)
        self.maj_professor()    


    def on_comboboxTV_changed(self,widget): 
        self.maj_professor()
        
    def on_comboboxTS_changed(self,widget): 
        self.maj_professor()    
        
    def on_comboboxCR_changed(self,widget): 
        self.maj_professor()    
        
    def on_comboboxSU_changed(self,widget): 
        self.maj_professor()            
        
    def on_comboboxGR_changed(self,widget): 
        self.maj_professor()    
        
    def on_comboboxAP_changed(self,widget): 
        self.maj_professor()    
        
    def on_comboboxS1_changed(self,widget): 
        self.maj_professor()    
        
    def on_comboboxS2_changed(self,widget): 
        self.maj_professor()    
        
    def on_comboboxS3_changed(self,widget): 
        self.maj_professor()    
        
    #-------------------------------------------------------------
    # Lancement de l'application
    #-------------------------------------------------------------          
    def on_buttonLancer_clicked(self,widget):   
        os.system(self.Texte_Compilation)
        
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Professor()
    gtk.main()

